@use crate::templates::base_html;
@use crate::templates::labels_html;
@use crate::templates::downloads_html;
@use crate::templates::search_icon_html;
@use crate::templates::deps_list_html;
@use crate::limit_text_len;
@use crate::limit_text_len_mid;
@use crate::iter::*;
@use crate::Urler;
@use crate::CratePage;
@use crate::Contributors;
@use rich_crate::Origin;
@use cargo_toml::Edition;
@use rich_crate::MaintenanceStatus;
@use std::ops::Div;
@use udedokei::LanguageExt;
@use kitchen_sink::ABlockAction;

@(url: &Urler, c: &CratePage<'_>)

@:base_html(&c.page(url), {
  <div typeof="SoftwareApplication" @if c.is_obsolete {class="obsolete-crate"}>
  <header id="package" @if c.ver.is_yanked() || c.ver.is_spam() || c.banned {class="yanked"}
    else {@if c.ver.is_nightly() {class="nightly"}}>
    <div class="inner-col">
    @:search_icon_html()
    <div class="breadcrumbs" typeof="BreadcrumbList">
    <h1>
      <span property="itemListElement" typeof="ListItem"><a accesskey="s" property="item"
        typeof="WebPage" href="/"><span property="name">Lib</span>.rs</a><meta
        property="position" content="1"></span>
    </h1>
     ›
    @if !c.ver.category_slugs().is_empty() {
      <span class="categories @if !c.ver.keywords().is_empty() {has-keywords}" role="navigation" aria-label="Categories">
      @for (last, (major, cat)) in c.category_slugs_unique().iter().enumerate().identify_last() {
        @for (last, (i, subcat)) in cat.iter().enumerate().identify_last() {
          @if major < 2 {
            <span property="itemListElement" typeof="ListItem"><a href="@url.category(subcat, Default::default())"
              title="@subcat.short_description" property="item" typeof="WebPage"><span
              property="name">@subcat.name</span></a><meta property="position" content="@(i+2)"></span>
          } else {
            <a href="@url.category(subcat, Default::default())" title="@subcat.short_description">@subcat.name</a>
          }
          @if !last {›}
        }
        @if !last {|}
      }
      @if let Some(parent) = c.parent_crate() {
        › <span class="parent-crate"><a href="@url.krate(&parent)">@parent.capitalized_name()</a></span>
      }
      </span>
    }
    </div>
    @if let Some(keywords) = c.keywords_populated() {
      <span class="keywords">
        <span>
          @for (key, link) in keywords.iter().take(3) {
              <a property="applicationCategory" @if *link {href="@url.keyword(key)"} class=keyword><span>#</span>@key</a>
          }
        </span>
        @for (key, link) in keywords.iter().skip(3) {
          <a property="applicationCategory" @if *link {href="@url.keyword(key)"} class=keyword><span>#</span>@key</a>
        }
      </span>
    }
    <h2>
      @:labels_html(c.ver, c.is_build_or_dev(), c.is_unmaintained, c.deprecation_reason.as_deref().unwrap_or_default())

      <span property="name">
      @if c.ver.is_yanked() || c.ver.is_spam() || c.ver.maintenance() == MaintenanceStatus::Deprecated {
        <del>@c.ver.short_name()</del>
      } else {
        @if let Some((repo, package)) = c.ver.origin().simple_repo() {
          @if let Some(l) = c.ver.repository_http_url() {
            @if let Origin::GitHub{..} = c.ver.origin() {
              <a class="gh-logo" href="@l.project_url" @c.rel_nofollow()><svg width="32" height="32" fill="currentColor" viewBox="0 0 16 16"><title>GitHub</title><path fill-rule="evenodd" d="M8 0C3.58 0 0 3.58 0 8c0 3.54 2.29 6.53 5.47 7.59.4.07.55-.17.55-.38 0-.19-.01-.82-.01-1.49-2.01.37-2.53-.49-2.69-.94-.09-.23-.48-.94-.82-1.13-.28-.15-.68-.52-.01-.53.63-.01 1.08.58 1.23.82.72 1.21 1.87.87 2.33.66.07-.52.28-.87.51-1.07-1.78-.2-3.64-.89-3.64-3.95 0-.87.31-1.59.82-2.15-.08-.2-.36-1.02.08-2.12 0 0 .67-.21 2.2.82.64-.18 1.32-.27 2-.27.68 0 1.36.09 2 .27 1.53-1.04 2.2-.82 2.2-.82.44 1.1.16 1.92.08 2.12.51.56.82 1.27.82 2.15 0 3.07-1.87 3.75-3.65 3.95.29.25.54.73.54 1.48 0 1.07-.01 1.93-.01 2.2 0 .21.15.46.55.38A8.013 8.013 0 0 0 16 8c0-4.42-3.58-8-8-8z"></path></svg></a>
            }
            @if let Origin::GitLab{..} = c.ver.origin() {
              <a class="gh-logo" href="@l.project_url" @c.rel_nofollow()><svg width="32" height="32" fill="currentColor" viewBox="125 180 340 200"><title>GitLab</title><path d="M461.48 298.35l-17.78-54.63a7.72 7.72 0 0 0-.43-1.47l-35.67-109.8a14.18 14.18 0 0 0-13.54-9.67 13.94 13.94 0 0 0-13.38 9.75l-34 104.63H239.37l-34.05-104.63a13.94 13.94 0 0 0-13.32-9.75h-.08a14.22 14.22 0 0 0-13.5 9.76l-35.7 109.93c0 .1-.08.18-.11.28l-18.1 55.61a20.29 20.29 0 0 0 7.37 22.71L288.26 434.7a8 8 0 0 0 9.45-.05l156.41-113.58a20.28 20.28 0 0 0 7.36-22.72m-233.75-45.13l43.59 134.16-104.64-134.16m148.05 134.19l41.8-128.62 1.8-5.57h61.1L324.76 374.5m69.44-231.67l30.63 94.33h-61.31m-22.03 16l-30.37 93.46L293 402.28l-48.42-149.12m-52.73-110.33l30.69 94.33h-61.27m-19.98 70.97a4.31 4.31 0 0 1-1.56-4.83l13.44-41.3 98.57 126.37m192.98-80.24l-110.46 80.21.37-.48L432.83 262l13.44 41.28a4.31 4.31 0 0 1-1.55 4.84"/></svg></a>
            }
          }
          @repo.owner<span class=un>/</span><wbr>@for (last, part) in package.split('_').identify_last() {@part@if !last {<span class=un>_<wbr></span>}}
        } else {
          @for (last, part) in c.ver.short_name().split('_').identify_last() {@part@if !last {<span class=un>_<wbr></span>}}
        }
      }
      </span>

    </h2>
    @if !c.blocklist_must_remove_data {
      @if let Some(desc) = c.ver.description() {
        @if !c.has_no_readme_or_lib() {
          <p class=desc>@c.render_maybe_markdown_str(desc)</p>
        }
      }
    }
    @if !c.blocklist_must_remove_data {
    <p class=byline>
      @if let Some(Contributors {authors, owners, co_owned, contributors, period_after_authors, contributors_as_a_team}) = Some(c.all_contributors()) {
        @if c.ver.is_yanked() {
          was
        }
        @if !authors.is_empty() { by }
        @for (last, a) in authors.iter().identify_last() {
          @if let Some(l) = c.author_link(url, a) {
            <a href="@l.url" @l.rel @if a.owner {class="owner" title="owner@if a.not_a_person {/team/bot}: @a.github_login().unwrap_or_default()"} else {class="contributor" title="contributor: @a.github_login().unwrap_or_default()"}
              property="author" typeof="@if a.not_a_person {Organization} else {Person}">@if a.github_login().is_some_and(|l| c.blocklist_actions.iter().any(|a| matches!(a, ABlockAction::Ban{login,..} if &**login == l))) {⛔️
              }<span property="name">@limit_text_len(&l.label, 10, 60)</span></a>@if !last {,} else {@if period_after_authors {.}}
          } else {
            @limit_text_len(a.name(), 10, 50)@if !last {,} else {@if period_after_authors {.}}
          }
        }
        @if contributors > 1 {
          <span class=contributors>@if !contributors_as_a_team && !authors.is_empty() {and}
          @if let Some(repo) = c.ver.repository() {
            @if contributors_as_a_team {(}<a href="@repo.contributors_http_url()" @c.rel_nofollow()>@if contributors == 100 {over }@contributors contributors</a>@if contributors_as_a_team {)}@if !owners.is_empty() {.}
          } else {
            @contributors contributors@if contributors_as_a_team {)}@if !owners.is_empty() {.}
          }
          </span>
        }
        @if !owners.is_empty() {
          <span class=coowners>
          <span>@if co_owned {Co-owned} else {Owned}</span>
          by @for (last, a) in owners.iter().identify_last() {
            @if let Some(l) = c.author_link(url, a) {
              <a href="@l.url" @if a.owner {class="owner" title="owner@if a.not_a_person {/team/bot}: @a.github_login().unwrap_or_default()"}
                @l.rel property="author" typeof="@if a.not_a_person {Organization} else {Person}"><span property="name">@limit_text_len(&l.label, 10, 60)</span></a>@if !last {,} else {.}
            } else {
              @a.name()@if !last {,} else {.}
            }
          }
          </span>
        }
      }
    </p>
    }
    <nav><ul>
      @if !c.ver.is_yanked() {
        @if c.show_audit_link {
          @if let Some(revlink) = url.reviews(c.ver.origin()) {
            <li><a href="@revlink" class="button">Audit</a></li>
          }
        }
        @if !c.blocklist_must_remove_data && !c.banned {
          <li><a href="@url.install(c.ver.origin())" class="button">Install</a></li>
          @if let Some(doc) = c.api_reference_url() {
            <li><a href="@doc">API reference</a></li>
          }
        }
      }
      @if !c.blocklist_must_remove_data {
        @for (l, detail) in c.repository_links(url) {
          <li>@if detail.is_some() {<span>}<a href="@l.url" @l.rel @if c.ver.homepage().is_none() {property="url"}>@limit_text_len(&l.label, 10, 40)</a>
            @if let Some(l) = detail { (<a @l.rel href="@l.url">@limit_text_len(&l.label, 10, 40)</a>)</span> }
          </li>
        }
        @if let Some(l) = c.documentation_link() {
          <li><a href="@l.url" @l.rel>@limit_text_len_mid(&l.label, 40)</a></li>
        }
        @if let Some(l) = c.homepage_link() {
          <li><a href="@l.url" @l.rel property="url" >@limit_text_len_mid(&l.label, 40)</a></li>
        }
      }
    </ul></nav>
    </div>
  </header>
  <main>
    <div class="inner-col">
      @if c.blocklist_must_remove_data || c.banned {
        <aside>
        @if c.banned {
          <h3>⛔️ This crate has been hidden ⛔️</h3>
        } else {
          <h3>Owner of this crate does not want it to be on lib.rs</h3>
        }
        @for r in &c.blocklist_actions {
          @if let ABlockAction::Ban{why,login} = r {
            <p>Owner of this crate (@login) is not welcome on lib.rs: <i>@why</i></p>
          }
          @if let ABlockAction::Block(reason, rurl) = r {
            <blockquote>@reason@if let Some(rurl) = rurl {<a rel="noindex nofollow" href="@rurl">*</a>}</blockquote>
            @if let Some(url) = url.crates_io_crate(c.ver.origin()) {
              <hr>
              <p><a href="@url">See this crate on crates.io</a></p>
            }
          }
        }
        </aside>
      }
      @if !c.blocklist_must_remove_data {
        @if c.banned { <details class=reveal><summary>Show the crate…</summary> }
      <section id="readme-deps">
        <div>
          <section class="about-crate">
            <section id="versions">
              @if let Some(parts) = c.version_stats_summary() {
                <h3>
                  @if let Some(verurl) = url.all_versions(c.ver.origin()) {
                    <a href="@verurl">@parts.0</a>
                  } else {
                    @parts.0
                  }
                  @if let Some(extra) = parts.1 {<span>@extra</span>}
                </h3>
              }
              @if c.edition() == Edition::E2015 {
                <p class="edition-2018">Uses old Rust 2015</p>
              }
              <table>
                @for (i,gr) in c.top_versions.iter().enumerate() {
                  <tr><th content="@gr.ver.num" @if i == 0 {property="softwareVersion"}>
                    @if c.is_version_new(&gr.ver, i) {
                      @if let Some(churl) = &c.changelog_url {
                        <a href="@churl">
                      }
                      <span class=new vocab="" property="">new</span>
                    }
                    @if let Some((v, suffix)) = gr.ver.num.split_once('+') {
                      @limit_text_len(v, 10, 25)<span>+@limit_text_len(suffix, 5, 20)</span>
                    } else {
                      @limit_text_len(gr.ver.num, 10, 25)
                    }
                    @if c.changelog_url.is_some() && c.is_version_new(&gr.ver, i) { </a> }
                  </th><td @if i == 0 {property="datePublished"} class="date">
                    @if gr.ver.yanked {
                      <del>@CratePage::format(&gr.ver.created_at)</del>
                    } else {
                      @CratePage::format(&gr.ver.created_at)
                    }
                  </td></tr>
                }
              </table>
            </section>

            <section id="downloads">
              @if let Some(url) = &c.security_advisory_url {
                <p><a href="@url">⚠️ Issues reported</a></p>
              }

              @if let Some((top, cat)) = c.top_category() {
                <p class="top-n">#<b>@top</b> in <a href="@url.category(cat, Default::default())" title="@cat.description">@cat.name</a></p>
              } else {
                @if let Some((top, keyword)) = c.top_keyword() {
                  <p class="top-n">#<b>@top</b> in <a href="@url.keyword(&keyword)">#@keyword</a></p>
                }
              }
              @if let Some(dl) = c.downloads_per_month() {
                @if dl > 50 {
                  @if let Some(g) = c.download_graph(182, 56) {
                    @:downloads_html(&g)
                  }
                }
              } else {
                @if let Some((stars, watchers)) = c.github_stargazers_and_watchers() {
                  <p><b>@c.format_number(stars)</b> star@if stars != 1 {s} & <b>@c.format_number(watchers)</b> watcher@if watchers != 1 {s}</p>
                }
              }
              <p>
                @if let Some(dl) = c.downloads_per_month() {
                  @if dl > 20 {
                    <b>@c.format_number(dl)</b> downloads per month
                  }
                }
                @if let Some(d) = c.dependents_stats() {
                  @if d.direct > 0 {
                  <br>
                    @if d.direct == 1 && (d.deps == 1 || d.former_glory < 0.8) {
                      @if let Some(name) = d.name {
                        Used in <a href="@url.crate_by_origin(&Origin::from_crates_io_name(name))">@limit_text_len(name, 10, 25)</a>
                      }
                    } else {
                      @if d.deps != d.direct && d.former_glory > 0.7 {
                          @if d.direct == 1 {
                            Used in <b>@c.format_number(d.deps)</b> crate@if d.deps != 1 {s}
                            @if let Some(name) = d.name {
                              (via <a href="@url.crate_by_origin(&Origin::from_crates_io_name(name))">@limit_text_len(name, 10, 25)</a>)
                            }
                          } else {
                            @if let Some(link) = url.reverse_deps(c.ver.origin()) {
                              Used in <a href="@link"><b>@c.format_number(d.deps)</b> crate@if d.deps != 1 {s}
                              (@c.format_number(d.direct)&nbsp;directly)</a>
                            }
                          }
                      } else {
                        @if let Some(link) = url.reverse_deps(c.ver.origin()) {
                          @if d.former_glory < 0.3 {
                            <a href="@link">This crate has lost popularity</a>
                          } else {
                            Used in <a href="@link">@if d.direct > 5 && d.former_glory < 0.9 {fewer than} <b>@c.format_number(d.direct)</b>&nbsp;crate@if d.direct != 1 {s}</a>
                          }
                        }
                      }
                    }
                }}
              </p>
            </section>
            <section id="sloc">
              <section id="license">
                @if let Some(lic) = c.license_name() {
                  <b property="license">@limit_text_len(lic, 10, 40)</b>
                  @if lic.len() < 8 && c.viral_license.is_none() {
                    license
                  }
                } else {
                  @if let Some(filename) = c.license_file() {
                    <b title="@filename.display()">Custom license</b>
                  }
                }
                @if let Some(ref vir) = c.viral_license {
                  and
                  @if vir.optional {
                    maybe
                  }
                  <a href="@url.crate_by_origin(&vir.origin)">@limit_text_len(&vir.license, 10, 40)</a>
                  @if !vir.optional && vir.license.len() < 8 {
                    licenses
                  }
                }
              </section>

              @if let Some(sz) = &c.sizes {
                <p>
                  <span title="@(c.format_kbytes(sz.tarball)) as tarball">@if sz.tarball > 1000000 || sz.uncompressed > 10000000 {
                    <b>@c.format_kbytes(sz.tarball.max(sz.uncompressed))</b>
                  } else {
                    @c.format_kbytes(sz.tarball.max(sz.uncompressed))
                  }</span>
                  @if let Some((total, _)) = c.lang_stats {
                    @if total >= 50 {
                      <br>
                      @if total >= 1000 {
                        @if let Some((val, unit)) = Some(c.format_knumber(total)) {
                          <span title="@c.format_number(total)">
                            @if total > 20000 {
                              <b>@val@unit</b>
                            } else {
                              @val@unit
                            }
                          </span>
                          <abbr title="Lines of code, excluding comments">SLoC</abbr>
                        }
                      } else {
                        @total <span title="Lines of code, excluding comments">lines</span>
                      }
                    }
                  }
                </p>
                @if let Some((total, stats)) = &c.lang_stats {
                  @if let Some(sloc) = c.langs_chart(stats, 360) {
                    @if sloc.len() > 1 && *total > 1000 {
                      <svg viewBox="-1 -1 59 59" width="60" height="60">
                        @for (lang, lines, (x, w)) in sloc {
                          <path d="@CratePage::svg_path_for_slice(x,if x+w < 359 {w+1} else {w},360,58)" fill="@lang.color()"><title>@lang.name() @if let Some((val,unit)) = Some(c.format_knumber(lines.code as usize)) {@val@unit} SLoC @if lines.comments > 1 { // @c.format_fraction(lines.comments as f64 / (lines.code+lines.comments) as f64) comments }</title></path>
                        }
                      </svg>
                    }
                  }
                }
              }
              @if !c.suspicious_binary_files.is_empty() {
                <p class=sus-files>Contains
                  @for (last, f) in c.suspicious_binary_files.iter().take(6).identify_last() {
                    (<b>@f.kind</b>, @c.format_kbytes(f.size)) <span>@f.path.display()</span>@if !last {,}
                  }
                  @if c.suspicious_binary_files.len() > 6 { <a href="@url.reviews(c.ver.origin()).unwrap_or_default()">and @(c.suspicious_binary_files.len()-6) more</a>.}
                </p>
              }
            </section>
          </section>

          @if let Some(readme) = c.ver.readme() {
              <section id=readme class="readme" vocab="">
                @c.render_readme(readme)
              </section>
          } else {
            @if c.has_no_readme_or_lib() {
              <section id=readme class="readme" vocab="">
                @if let Some(desc) = c.ver.description() {
                  <hr>
                  <p class=desc>@c.render_maybe_markdown_str(desc)</p>
                } else {
                  <p class=error>(This crate has no description)</p>
                }
              </section>
            }
          }

          @if c.is_readme_short_or_irrelevant() {
            @if let Some(intro) = c.render_lib_intro() {
              @if c.ver.readme().is_some() { <hr> }
              <section id=lib_intro class="readme" vocab="">
                @if c.ver.readme().is_some() {
                  <h3>
                    @if let Some(doc) = c.api_reference_url() {
                      <a href="@doc"><code>lib.rs</code></a>:
                    } else {
                      <code>lib.rs</code>:
                    }
                  </h3>
                }
                @intro
              </section>
            }
          }
        </div>
        <section id="deps">
          @if let Some((normal, dev, build)) = c.direct_dependencies() {
            @if c.has_runtime_deps() || c.links().is_some() {
                <h4>Dependencies</h4>
            } else {
              <h4>No runtime deps</h4>
              @if dev.is_empty() && build.is_empty() && normal.is_empty() && !c.ver.has_buildrs() {
                @if let Some(f) = c.non_dep_features() {
                  <h4><a href="@url.features(c.ver.origin(), None)">Features</a></h4>
                  <ul>
                    @for f in f.iter() {<li><a href="@url.features(c.ver.origin(), Some(f))" class="feature">@f</a></li>}
                  </ul>
                }
              }
            }
            @if let Some(sz) = &c.sizes {
              @if sz.typical.tarball > 1000000 || sz.typical.tarball > sz.tarball.div(2) {
                <p>
                  <span title="amortized size; approx. @c.format_kbytes(sz.typical.tarball) compressed">@if sz.typical.tarball > 8000000 || sz.typical.uncompressed > 50000000 {
                    ~<b>@c.format_kbytes_range(sz.minimal.uncompressed, sz.typical.tarball.max(sz.typical.uncompressed))</b>
                  } else {
                    ~@c.format_kbytes_range(sz.minimal.uncompressed, sz.typical.tarball.max(sz.typical.uncompressed))
                  }</span>
                  <br>
                  @if sz.typical.lines >= 10000 {
                    @if let Some((val, unit)) = Some(c.format_knumber(sz.typical.lines)) {
                      <span title="estimated">~@val@unit</span> <abbr title="approx. additional lines of code">SLoC</abbr>
                    }
                  }
                </p>
              }
            }
            <nav aria-label="Dependencies">
            <ul @if normal.len() > 4 {class="long"}>
              @:deps_list_html(c, url, normal, None)
              @if let Some(links) = c.links() {
                <li><span class="label label-build">links</span> <code>@links</code></li>
              }
            </ul>
            <ul class="dev @if dev.len() > 4 {long}">
              @if c.ver.has_buildrs() {
                <li><span class="label label-build">build</span> <code>build.rs</code></li>
              }
              @:deps_list_html(c, url, build, Some("build"))
              @:deps_list_html(c, url, dev, Some("dev"))
            </ul>
              @if !dev.is_empty() || !build.is_empty() || !normal.is_empty() || c.ver.has_buildrs() {
                @if let Some(f) = c.non_dep_features() {
                  <h4 class="other-features"><a href="@url.features(c.ver.origin(), None)">Other feature@if f.len() != 1 {s}</a></h4>
                  <ul class="features @if f.len() > 4 {long}">
                    @for f in f.iter().take(20) {
                      <li><a href="@url.features(c.ver.origin(), Some(f))" class="feature">@limit_text_len_mid(f, 50)</a></li>
                    }
                    @if f.len() > 20 {
                       <li><a href="@url.features(c.ver.origin(), None)">and more</a>…</li>
                    }
                  </ul>
                }
              }
            </nav>
          } else {
            <p class="error">Dependencies unknown</p>
          }
        </section>
      </section>
        @if c.banned { </details> }
      }
    </div>
  </main>
  </div>

  <footer>
    <div class="inner-col">
      @if !c.blocklist_must_remove_data {
        @if let Some(crates) = c.same_namespace_crates() {
            <nav class=seealso aria-label="Related">
              Related:
              @for (last, cra) in crates.iter().identify_last() {
                <a href="@url.krate(cra)">@cra.short_name()</a>@if !last {,}
              }
            </nav>
        }
      }
      @if let Some(crates) = c.related_crates() {
          <nav class=seealso aria-label="See also">
            See also:
            @for (last, origin) in crates.iter().identify_last() {
              <a href="@url.crate_by_origin(origin)">@origin.package_name_icase()</a>@if !last {,}
            }
          </nav>
      }
      <aside role="contentinfo"><p><a href="/"><b>Lib.rs</b></a> is an unofficial list of Rust/Cargo crates, created by <a href="https://github.com/kornelski">kornelski</a>. It contains data from <a href="/data-processing">multiple sources, including heuristics, and manually curated data</a>. Content of this page is not necessarily endorsed by the authors of the crate. This site is not affiliated with nor endorsed by the Rust Project.
        @if c.blocklist_actions.is_empty() { If something is missing or incorrect} else {
          Blocks and bans are applied manually. To report or appeal},
        please <a href="https://gitlab.com/lib.rs/main/issues/new">file a bug</a>.</p></aside>
    </div>
  </footer>
})
